"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const os_1 = require("os");
const path_1 = require("path");
const site_1 = require("./site");
class ConfigStore {
    constructor() {
        this.configData = { sites: [] };
    }
    loadConfigModule(dirname) {
        return require(path_1.resolve(dirname, '.vanilla-clipper', 'config.js'));
    }
    load() {
        try {
            this.configData = this.loadConfigModule(process.cwd());
        }
        catch (error) {
            this.configData = this.loadConfigModule(os_1.homedir());
        }
        this.sites = new site_1.Sites(this.configData.sites);
    }
}
exports.ConfigStore = ConfigStore;
exports.config = new ConfigStore();
exports.config.load();
//# sourceMappingURL=index.js.map