"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const rain_1 = require("@yarnaimo/rain");
const fs_extra_1 = require("fs-extra");
const config_store_1 = require("../config-store");
const utils_1 = require("../utils");
const VPage_1 = require("./VPage");
const isTest = process.env.NODE_ENV === 'test';
const puppeteer = require(isTest ? 'puppeteer' : 'puppeteer-core');
class VBrowser {
    constructor(browser) {
        this.browser = browser;
    }
    static async launch(noSandbox = false, _a = {}, lang) {
        var { args = [] } = _a, options = __rest(_a, ["args"]);
        if (lang)
            args.push(`--lang=${lang}`);
        let executablePath;
        let userDataDir;
        if (rain_1.isNot.undefined(options.executablePath)) {
            executablePath = options.executablePath;
            utils_1.sig.info('Using %s', executablePath);
        }
        else {
            executablePath = utils_1.findChrome();
        }
        if (options.userDataDir) {
            userDataDir = options.userDataDir;
            fs_extra_1.ensureDir(userDataDir);
            utils_1.sig.info('User Data Directory: %s', userDataDir);
        }
        const browser = await puppeteer.launch(Object.assign({ ignoreHTTPSErrors: true, executablePath,
            userDataDir }, options, { args: [...args, ...(noSandbox ? utils_1.noSandboxArgs : [])] }));
        return new VBrowser(browser);
    }
    async login(vPage, url, label) {
        const site = config_store_1.config.sites.findSite(url);
        if (!site)
            return [];
        // const vPage = new VPage(await this.browser.newPage())
        const cookies = await config_store_1.config.sites.login(site, vPage, label);
        // await vPage.close()
        return cookies;
    }
    async newPage({ url, label, device, } = {}) {
        const vPage = new VPage_1.VPage(await this.browser.newPage());
        if (device)
            await vPage.frame.emulate(device);
        if (url) {
            const cookies = await this.login(vPage, url, label);
            await vPage.goto(url);
            // await vPage.page.setCookie(...cookies)
            // await vPage.page.reload()
        }
        return vPage;
    }
    async close() {
        await this.browser.close();
    }
}
exports.VBrowser = VBrowser;
//# sourceMappingURL=VBrowser.js.map