import { ElementHandle, EvaluateFn } from 'puppeteer-core';
import { VFrame } from '..';
import { StyleSheetData } from '../types';
export declare class VDocument {
    vFrame: VFrame;
    private documentHandle;
    static create(vFrame: VFrame, fn: EvaluateFn): Promise<VDocument>;
    private constructor();
    eval<T, A extends any[]>(fn: (document: Document, ...args: A) => T, ...args: A): Promise<T>;
    $(selector: string): Promise<ElementHandle<Element> | null>;
    $$(selector: string): Promise<ElementHandle<Element>[]>;
    getSheetDataList(): Promise<StyleSheetData[]>;
    setUuidToIFrames(): void;
}
