"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const config_store_1 = require("../config-store");
const VFrame_1 = require("./VFrame");
class VPage extends VFrame_1.VFrame {
    constructor(frame) {
        super(frame);
        this.frame = frame;
        this.isRoot = true;
    }
    async close() {
        return this.frame.close();
    }
    async goto(url) {
        await this.frame.goto(url, { waitUntil: 'networkidle2' });
        await this.frame.waitFor(2000);
    }
    async login(url, label) {
        const site = config_store_1.config.sites.findSite(url);
        if (!site)
            return;
        await config_store_1.config.sites.login(site, this, label);
    }
}
exports.VPage = VPage;
//# sourceMappingURL=VPage.js.map