"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const VPluginStore_1 = require("./VPluginStore");
exports.jsdomPlugins = new VPluginStore_1.VPluginStore();
// clean
exports.jsdomPlugins.add(getElements => {
    const els = getElements('script', 'style', 'link[rel~=stylesheet]', 'link[rel~=dns-prefetch]', 'link[rel~=preload]', 'link[rel~=preconnect]', 'link[rel~=prefetch]', 'link[rel~=prerender]');
    els.forEach(el => el.remove());
});
// remove ads
exports.jsdomPlugins.add(getElements => {
    const els = getElements('ins.adsbygoogle', 'a[href^="https://rs.adapf.com"]', 'iframe[src^="https://tpc.googlesyndication.com"]', 'iframe[src^="https://googleads.g.doubleclick.net"]');
    els.forEach(el => el.remove());
});
// relative url to absolute
exports.jsdomPlugins.add(getElements => {
    const els = getElements('[href]', '[src]');
    els.forEach((el) => {
        const { href, src } = el;
        if (href)
            el.href = href;
        if (src)
            el.src = src;
    });
});
//# sourceMappingURL=index.js.map