import { VDocument } from './core/VDocument';
export declare type TailArguments<T> = T extends (arg1: any, ...args: infer U) => any ? U : never[];
export interface DataMap {
    [url: string]: string;
}
export declare type DataListItem = [string, string];
export declare type StyleSheetData = {
    type: 'link';
    link: string;
} | {
    type: 'text';
    text: string;
} | {
    type: 'error';
    error: Error;
};
export declare type VPlugin = (vDocument: VDocument) => Promise<void>;
export interface VPluginStore {
    beforeLoad: VPlugin[];
    afterLoad: VPlugin[];
}
export interface IFrameData {
    uuid: string;
    html: string;
}
