"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rain_1 = require("@yarnaimo/rain");
const createVAttrFn = (attrName) => (value) => `[${attrName}${value ? `="${value.replace(/"/g, '\\"')}"` : ''}]`;
exports.getVAttrSelector = {
    src: createVAttrFn('data-vanilla-clipper-src'),
    href: createVAttrFn('data-vanilla-clipper-href'),
    style: createVAttrFn('data-vanilla-clipper-style'),
    script: createVAttrFn('data-vanilla-clipper-script'),
    iframeUuid: createVAttrFn('data-vanilla-clipper-iframe-uuid'),
};
exports.selectorsToString = (...selectors) => selectors
    .map(s => rain_1.is.string(s)
    ? s
    : s.not.reduce((prev, current) => `${prev}:not(${current})`, s.selector))
    .join(', ');
exports.createElementFinder = (document) => (...selectors) => [
    ...document.querySelectorAll(exports.selectorsToString(...selectors)),
];
//# sourceMappingURL=element.js.map