import got from 'got'
import { JSDOM } from 'jsdom'
import { DateTime } from 'luxon'

const articleURLs = [
    'https://webnewtype.com/column/color/67201/',
    'https://webnewtype.com/column/color/67899/',
    'https://webnewtype.com/column/color/68601/',
    'https://webnewtype.com/column/color/69299/',
    'https://webnewtype.com/column/color/70044/',
    'https://webnewtype.com/column/color/70945/',
    'https://webnewtype.com/column/color/71707/',
    'https://webnewtype.com/column/color/72409/',
    'https://webnewtype.com/column/color/73153/',
    'https://webnewtype.com/column/color/74036/',
    'https://webnewtype.com/column/color/74918/',
    'https://webnewtype.com/column/color/75825/',
    'https://webnewtype.com/column/color/76761/',
    'https://webnewtype.com/column/color/77848/',
    'https://webnewtype.com/column/color/78726/',
    'https://webnewtype.com/column/color/79696/',
    'https://webnewtype.com/column/color/80728/',
    'https://webnewtype.com/column/color/81606/',
    'https://webnewtype.com/column/color/82468/',
    'https://webnewtype.com/column/color/83967/',
    'https://webnewtype.com/column/color/85197/',
    'https://webnewtype.com/column/color/86473/',
    'https://webnewtype.com/column/color/87556/',
    'https://webnewtype.com/column/color/89542/',
    'https://webnewtype.com/column/color/90960/',
    'https://webnewtype.com/column/color/92247/',
    'https://webnewtype.com/column/color/93626/',
    'https://webnewtype.com/column/color/94973/',
    'https://webnewtype.com/column/color/96442/',
    'https://webnewtype.com/column/color/97670/',
    'https://webnewtype.com/column/color/99043/',
    'https://webnewtype.com/column/color/100250/',
    'https://webnewtype.com/column/color/101634/',
    'https://webnewtype.com/column/color/103119/',
    'https://webnewtype.com/column/color/104469/',
    'https://webnewtype.com/column/color/106501/',
    'https://webnewtype.com/column/color/107895/',
    'https://webnewtype.com/column/color/108881/',
    'https://webnewtype.com/column/color/110108/',
    'https://webnewtype.com/column/color/111550/',
    'https://webnewtype.com/column/color/113675/',
    'https://webnewtype.com/column/color/114866/',
    'https://webnewtype.com/column/color/116188/',
    'https://webnewtype.com/column/color/117770/',
    'https://webnewtype.com/column/color/119196/',
    'https://webnewtype.com/column/color/120786/',
    'https://webnewtype.com/column/color/122193/',
    'https://webnewtype.com/column/color/124358/',
    'https://webnewtype.com/column/color/125859/',
    'https://webnewtype.com/column/color/127376/',
    'https://webnewtype.com/column/color/128780/',
    'https://webnewtype.com/column/color/130348/',
    'https://webnewtype.com/column/color/131920/',
    'https://webnewtype.com/column/color/133574/',
    'https://webnewtype.com/column/color/135248/',
    'https://webnewtype.com/column/color/136796/',
    'https://webnewtype.com/column/color/138319/',
    'https://webnewtype.com/column/color/139836/',
    'https://webnewtype.com/column/color/141355/',
    'https://webnewtype.com/column/color/143556/',
    'https://webnewtype.com/column/color/145191/',
    'https://webnewtype.com/column/color/146401/',
    'https://webnewtype.com/column/color/147954/',
    'https://webnewtype.com/column/color/149722/',
    'https://webnewtype.com/column/color/151555/',
    'https://webnewtype.com/column/color/154268/',
    'https://webnewtype.com/column/color/156018/',
    'https://webnewtype.com/column/color/157940/',
    'https://webnewtype.com/column/color/159505/',
    'https://webnewtype.com/column/color/161893/',
    'https://webnewtype.com/column/color/163630/',
    'https://webnewtype.com/column/color/165387/',
    'https://webnewtype.com/column/color/167043/',
    'https://webnewtype.com/column/color/168548/',
    'https://webnewtype.com/column/color/170305/',
    'https://webnewtype.com/column/color/172685/',
    'https://webnewtype.com/column/color/174394/',
]

async function get(url: string) {
    const { body } = await got.get(url)
    const {
        window: { document },
    } = new JSDOM(body)

    const [title, publishedAtString, mainText, additionalText] = [
        '.column_titleBox h1',
        '.column_titleInfoBox .columnDate',
        '.column_mainTextBox_second',
        '.column_additionalBox',
    ].map(selector => document.querySelector(selector)!.innerHTML.trim())

    const [y, M, d, H, m] = publishedAtString.match(/\d+/g)!
    const publishedAt = DateTime.fromISO(`${y}-${M}-${d}T${H}:${m}`).toISO()

    const imageURLs = [...document.querySelectorAll('.related_imgArea img')].map(img =>
        (img as HTMLImageElement).src.replace(/\/w\d+h\d+\/$/, '')
    )

    return { title, publishedAt, mainText, additionalText, imageURLs }
}

async function main() {
    const results = await Promise.all(articleURLs.slice(0, 20).map(get))
    console.log(JSON.stringify(results))
}

main()
